import java.io.*;
import java.net.ServerSocket;
import java.net.Socket;
import java.nio.charset.Charset;

public class FileSerwer {

    public static void main(String[] args) throws IOException {
        ServerSocket servsock = new ServerSocket(8888);
        while (true) {
            final Socket sock = servsock.accept();

            System.out.println("Accepted connection : " + sock);

            (new Thread() {
                public void run() {
                    try {
                        InputStream is = sock.getInputStream();
                        byte[] mybytearray = new byte[1000000000];
                        String name = new BufferedReader(new InputStreamReader(is))
                                .readLine();
                        System.out.println(name);
                        OutputStream os = sock.getOutputStream();
                        String mes = "ok\n";
                        os.write(mes.getBytes(Charset.forName("UTF-8")));
                        FileOutputStream fos = new FileOutputStream(name + ".png");
                        BufferedOutputStream bos = new BufferedOutputStream(fos);

                        // read 4 bytes containing the file size
                        byte[] bSize = new byte[4];
                        int offset = 0;
                        while (offset < bSize.length) {
                            int bRead = is.read(bSize, offset, bSize.length - offset);
                            offset += bRead;
                        }
                        // Convert the 4 bytes to an int
                        int fileSize;
                        fileSize = (int) (bSize[0] & 0xff) << 24
                                | (int) (bSize[1] & 0xff) << 16
                                | (int) (bSize[2] & 0xff) << 8
                                | (int) (bSize[3] & 0xff);

                        // buffer to read from the socket
                        // 8k buffer is good enough
                        byte[] data = new byte[8 * 1024];

                        int bToRead;
                        while (fileSize > 0) {
                            // make sure not to read more bytes than filesize
                            if (fileSize > data.length) bToRead = data.length;
                            else bToRead = fileSize;
                            int bytesRead = is.read(data, 0, bToRead);
                            if (bytesRead > 0) {
                                bos.write(data, 0, bytesRead);
                                fileSize -= bytesRead;
                            }
                        }
                        bos.close();

                        is.close();
                        bos.close();
                        sock.close();
                    } catch (Exception e) {
                        System.out.println(e.getStackTrace());
                    }
                }
            }).start();
        }
    }
}
