import org.bytedeco.javacpp.opencv_core;
import org.bytedeco.javacv.*;

import javax.imageio.ImageIO;
import java.awt.image.BufferedImage;
import java.io.File;

public class Stream  {

    public static BufferedImage getBufferedImage(Frame frame) {
        OpenCVFrameConverter.ToIplImage toIplImage = new OpenCVFrameConverter.ToIplImage();
        Java2DFrameConverter frameConverter = new Java2DFrameConverter();
        return frameConverter.convert(frame);
    }

    public static void main(String[] args) throws Exception {

        FFmpegFrameGrabber frameGrabber = new FFmpegFrameGrabber("http://192.167.1.100:8080/video");
        frameGrabber.start();

        BufferedImage image = getBufferedImage(frameGrabber.grabFrame());

        CanvasFrame canvasFrame = new CanvasFrame("Camera");
        canvasFrame.setCanvasSize(image.getWidth(), image.getHeight());

        int czy = 1000;
        while (canvasFrame.isVisible() && (image != null)) {
            image = getBufferedImage(frameGrabber.grabFrame());
            canvasFrame.showImage(image);
        }

        frameGrabber.stop();
        canvasFrame.dispose();
        System.exit(0);
    }
}
